<?php
if (!defined('ABSPATH')) die('-1');

if (!class_exists("WD_ASP_IndexTable_Action")) {
    /**
     * Class WD_ASP_IndexTable_Action
     *
     * Handles index table actions
     *
     * @class         WD_ASP_IndexTable_Action
     * @version       1.0
     * @package       AjaxSearchPro/Classes/Actions
     * @category      Class
     * @author        Ernest Marcinko
     */
    class WD_ASP_IndexTable_Action extends WD_ASP_Action_Abstract {

        function handle() {}

        function update( $post_id ) {

            if ( wp_is_post_revision( $post_id ) )
                return false;

            $it_options = get_option('asp_it_options');

            if ($it_options !== false) {
                $args = array();
                foreach ($it_options as $k => $o) {
                    $args[str_replace('it_', '', $k)] = $o;
                }
                $it_o = new asp_indexTable( $args );

                $post_status = get_post_status( $post_id );

                if ($post_status == 'trash') {
                    $it_o->removeDocument( $post_id, true );
                    return true;
                }

                $it_o->indexDocument( $post_id, true, true );
            }

        }


        function delete( $post_id ) {
            $it_o = new asp_indexTable();
            $it_o->removeDocument( $post_id, true );
        }

        function extend() {
            $asp_it_options = get_option('asp_it_options');

            if ($asp_it_options !== false) {
                $args = array();
                foreach ($asp_it_options as $k => $o) {
                    $args[str_replace('it_', '', $k)] = $o;
                }
                $it_obj = new asp_indexTable( $args );
                $res = $it_obj->extendIndex( );
                update_option("asp_it_cron", array(
                    "last_run"  => time(),
                    "result"    => $res
                ));
            }

        }

        function cron_extend() {
            // Index Table CRON
            if ( !wp_next_scheduled( 'asp_cron_it_extend' ) ) {

                $asp_it_options = get_option('asp_it_options');

                if ($asp_it_options !== false) {
                    if ( w_isset_def($asp_it_options['it_cron_enable'], 0) == 1 )
                        wp_schedule_event( time(), w_isset_def($asp_it_options['it_cron_period'], "hourly"), 'asp_cron_it_extend' );
                }
            }
        }

        // ------------------------------------------------------------
        //   ---------------- SINGLETON SPECIFIC --------------------
        // ------------------------------------------------------------
        public static function getInstance() {
            if ( ! ( self::$_instance instanceof self ) ) {
                self::$_instance = new self();
            }

            return self::$_instance;
        }
    }
}