<?php
if (!defined('ABSPATH')) die('-1');

if (!class_exists("WD_ASP_Deletecache_Handler")) {
    /**
     * Class WD_MS_Search_Handler
     *
     * Cache delete ajax request handler
     *
     * @class         WD_ASP_Handler_Abstract
     * @version       1.0
     * @package       AjaxSearchPro/Classes/Ajax
     * @category      Class
     * @author        Ernest Marcinko
     */
    class WD_ASP_Deletecache_Handler extends WD_ASP_Handler_Abstract {

        /**
         * Deletes the Ajax Search Pro directory
         */
        function handle() {
            print $this->delTree(ASP_PATH . DIRECTORY_SEPARATOR . "cache" . DIRECTORY_SEPARATOR);
            exit;
        }

        /**
         * Delete a directory tree
         *
         * @param $dir string
         * @return int files and directories deleted
         */
        private function delTree($dir) {
            $count = 0;
            $files = @glob($dir . '*', GLOB_MARK);
            foreach ($files as $file) {
                if (substr($file, -1) == '/')
                    @delTree($file);
                else
                    @unlink($file);
                $count++;
            }
            return $count;
        }

        // ------------------------------------------------------------
        //   ---------------- SINGLETON SPECIFIC --------------------
        // ------------------------------------------------------------
        public static function getInstance() {
            if ( ! ( self::$_instance instanceof self ) ) {
                self::$_instance = new self();
            }

            return self::$_instance;
        }
    }
}