<?php
if (!defined('ABSPATH')) die('-1');

if (!class_exists("WD_ASP_FormOverride_Filter")) {
    /**
     * Class WD_ASP_FormOverride_Filter
     *
     * Handles the default search form layout override
     *
     * @class         WD_ASP_FormOverride_Filter
     * @version       1.0
     * @package       AjaxSearchPro/Classes/Filters
     * @category      Class
     * @author        Ernest Marcinko
     */
    class WD_ASP_FormOverride_Filter extends WD_ASP_Filter_Abstract {

        function handle( $form = "" ) {
            $asp_st_override = get_option("asp_st_override", -1);

            if ( $asp_st_override > -1 && wd_asp()->instances->exists( $asp_st_override ) )
                return do_shortcode("[wpdreams_ajaxsearchpro id=".$asp_st_override."]");

            return $form;
        }

        // ------------------------------------------------------------
        //   ---------------- SINGLETON SPECIFIC --------------------
        // ------------------------------------------------------------
        public static function getInstance() {
            if ( ! ( self::$_instance instanceof self ) ) {
                self::$_instance = new self();
            }

            return self::$_instance;
        }
    }
}