<?php
/* Prevent direct access */
defined('ABSPATH') or die("You can't access this file directly.");

/* Option not set or deactivated, return */
if (
    empty($style["selected-show_frontend_tags"]) ||
    $style["selected-show_frontend_tags"]['active'] == 0
) return;

/* Let us make it a bit more accessible */
$_sfto = $style["selected-show_frontend_tags"];

if ($_sfto['source'] == "all") {
    // Limit all tags to 400. I mean that should be more than enough..
    $_sftags = get_terms("post_tag", array("number"=>400));
} else {
    $_sftags = asp_get_terms_ordered_by_ids("post_tag", $_sfto['tag_ids']);
}

if ( empty($_sftags) ) return;

if ($_sfto['source'] == "all") {
    $_sel_tags = $_sfto['default_tag'] != "" ? array($_sfto['default_tag']) : array();
} else {
    $_sel_tags = $_sfto["checked_tag_ids"];
}

?>
<fieldset>

    <?php if ( w_isset_def($style['frontend_tags_header'], "Filter by Tags") != "" ): ?>

    <legend><?php echo asp_icl_t( "Post tags filter header", w_isset_def($style['frontend_tags_header'], "Filter by Tags") ); ?></legend>

    <?php endif; ?>

    <?php if ($_sfto['display_mode'] == "checkboxes"): ?>

        <div class="tag_filter_box asp_sett_scroll">

        <?php foreach($_sftags as $_sftag): ?>

        <?php
        if ( $_sfto['source'] == "all" ) {
            if ($_sfto['all_status'] == "checked")
                $selected = 'checked="checked"';
            else
                $selected = '';
        } else {
            $selected = in_array($_sftag->term_id, $_sel_tags) ? 'checked="checked"' : '';
        }
        ?>

        <div class="asp_option_cat">
            <div class="option">
                <input type="checkbox" value="<?php echo $_sftag->term_id; ?>"
                       id="<?php echo $id; ?>post_tag_set_<?php echo $_sftag->term_id; ?>"
                       name="post_tag_set[]" <?php echo $selected; ?>/>
                <label for="<?php echo $id; ?>post_tag_set_<?php echo $_sftag->term_id; ?>"></label>
            </div>
            <div class="label">
                <?php echo $_sftag->name; ?>
            </div>
        </div>

        <?php endforeach; ?>

        </div>

    <?php elseif ($_sfto['display_mode'] == "dropdown"): ?>

        <div class="asp_select_label asp_select_single">

        <select name="post_tag_set">
        <?php foreach($_sftags as $_sftag): ?>
            <option value="<?php echo $_sftag->term_id; ?>"<?php echo in_array($_sftag->term_id, $_sel_tags) ? ' selected' : ''; ?>>
                <?php echo $_sftag->name; ?>
            </option>
        <?php endforeach; ?>
        </select>

        </div>

    <?php elseif ($_sfto['display_mode'] == "radio"): ?>

        <div class="tag_filter_box asp_sett_scroll">

            <?php foreach($_sftags as $k => $_sftag): ?>

                <label class="asp_label">
                <input type="radio" class="asp_radio" name="post_tag_set" value="<?php echo $_sftag->term_id; ?>"
                    <?php echo in_array($_sftag->term_id, $_sel_tags) || $k == 0 ? ' checked="checked"' : '' ; ?>>
                <?php echo $_sftag->name; ?></label><br>

            <?php endforeach; ?>

        </div>

    <?php endif; ?>

</fieldset>